<?php
class UserController extends ActionController {
	
	public function __construct($viewPath) {
		parent::__construct($viewPath);
	}
	
	public function create() {
		$req_fields = array('username', 'password', 'confirm');
		if ( empty($this->current_user) ||
			 ! $this->current_user->isAdministrator() ) {
			$this->redirect('/error/denied/');
		} elseif ($this->arrayContains($req_fields, $_POST)) {
			$usr = new User();
			$usr->username = $_POST['username'];
			$usr->setPassword($_POST['password']);
			if ($usr->checkPassword($_POST['confirm'])) {
				$usr->insert();
				$data = array('name'=>$usr->username);
				$this->view->setMessage('Successfully created user '.$usr->username, 'success');
			} else {
				$this->view->setMessage('Error creating user '.$usr->username, 'error');
			}
			$this->view->load("user_create", $data);
		} else {
			if (! empty($_POST)) {
				$this->view->setMessage('Error creating user - missing fields', 'error');
			}
			$this->view->load("user_create");
		}
		$this->view->render();
	}
	
	public function changePassword($username) {
		if ( empty($this->current_user) ||
			 ! $this->current_user->isAdministrator() ) {
			$this->redirect('/error/denied/');
		}
		
		$usr = User::GetByName($username);
		if (! $usr) {
			$this->view->setMessage('Specified user does not exist', 'error');
			$this->redirect('/user/list/');
		}
		
		$keys_set = $this->arrayContains(array('password', 'confirm'), $_POST);
		
		if ( $keys_set && $_POST['password'] == $_POST['confirm'] ) {
			$usr->SetPassword($_POST['password']);
			$usr->Save();
			$this->view->setMessage("Password changed", "success");
			$this->redirect('/user/list/');
		} elseif ( $keys_set && $_POST['password'] != $_POST['confirm']) {
			$this->view->setMessage("Passwords do not match");
		}
		$this->view->load('user_password', array('title'=> 'Change password'));
		$this->view->render();
	}
	
	public function login() {
		if ($this->current_user) {
			$this->redirect('/document/getlist/');
		}
		
		if ($this->arrayContains(array('username', 'password'), $_POST)) {
			$logged_in = Auth::login($_POST['username'], $_POST['password']);
			if ($logged_in) {
				$this->current_user = $_SESSION[User::CURR_USER];
				$this->redirect('/document/getlist/');
			} else {
				$this->view->setMessage("Invalid username or password.");
			}
		} 
		$this->view->load("user_login", array('title'=> 'User login'));
		$this->view->render();
	}
	
	public function logout() {
		unset($this->current_user);
		unset($_SESSION[Auth::CURR_USER]);
		$this->redirect('/user/login/');
	}
	
	public function getlist() {
		if ( empty($this->current_user) ||
			 ! $this->current_user->isAdministrator() ) {
			$this->redirect('/error/denied/');
		}
		
		$users = User::GetAll();
		$this->view->load('user_list', array('title'=> 'User list', 'users'=> $users));
		$this->view->render();
	}
	
}