<?php
class ActionController {
	
	protected $current_user;
	protected $db;
	protected $view;
    
    public $baseUrl = '';
	public $rootUrl = '/';
    public $useQueryString = false;
	
	protected function __construct($viewPath) {
		$this->db = new DB();
        $this->view = new View($viewPath, $this);
		if (isset($_SESSION[Auth::CURR_USER])) {
			$this->current_user = User::GetByName($_SESSION[Auth::CURR_USER]);
		} else {
			$this->current_user = null;
		}
		$this->view->current_user = $this->current_user;
	}
	
    /**
     * Utility method for calculating array subset based on keys.
     *
     * @param array $keys   Array of key values for which to check
     * @param array $array  The array in which to check for them
     * @return bool True if the array contains all the requested keys,
     *              false otherwise.
     */
    protected function arrayContains(array $keys, array $array) {
        foreach ($keys as $key) {
            if (! isset($array[$key])) return false;
        }
        return true;
    }
    
    public function route($ctl, $act, $data=null) {
        if ($this->useQueryString) {
            $ret = $this->baseUrl."?c=$ctl&a=$act";
            if ($data !== null) $ret .= "&d=$data";
        } else {
            $route = array($ctl, $act);
            if ($data !== null) $route[] = $data;
            $ret = $this->baseUrl . '/' . implode('/', $route);
        }
        return $ret;
    }
	
	public function link($res) {
		return $this->rootUrl . $res;
	}
    
	public function redirect($url) {
		if ($this->baseUrl) {
			$url = $this->baseUrl.$url;
		}
		header('Location: '.$url);
		exit;
	}
}
?>