<?php
class Document extends ActiveRecord {
	
	public $id = null;
	public $title = '';
	public $content = '';
	public $owner = null;
	
	protected $db;
	public static $dbconn;
	
	public function __construct($row=null) {
		$this->db = self::getDb();
		if ($row) {
			$this->id = $row['id'];
			$this->title = $row['title'];
			$this->content = $row['content'];
			$this->owner = User::GetByName($row['owner']);
		}
	}
	
	protected static function getDb() {
		if (! self::$dbconn) {
			self::$dbconn = new DB();
		}
		return self::$dbconn;
	}
	
	static public function GetAll() {
		$db = self::getDb();
		$rows = $db->SelectAllDocuments();
		$ret = array();
		foreach ($rows as $row) {
			$ret[] = new Document($row);
		}
		return $ret;
	}
	
	static public function GetById($id) {
		$db = self::getDb();
		$row = $db->SelectDocument($id);
		return new Document($row);
	}
	
	public function Insert() {
		$data = array('title'=>$this->title,
					  'content'=>$this->content,
					  'owner'=>$this->owner->username);
		$last_id = $this->db->InsertDocument($data);
		$this->id = $last_id;
	}
	
	public function Update() {
		$data = array('id'=>$this->id,
					  'title'=>$this->title,
					  'content'=>$this->content,
					  'owner'=>$this->owner->username);
		return $this->db->UpdateDocument($this->id, $data);
	}
	
	public function Delete() {
		$this->db->DeleteDocument($this->id);
	}
}