<?php
class Group {
	
	public $name = '';
	public $description = '';
	
	private $db = null;
	
	public function __construct($datarow=null) {
		$this->db = new DB();
		if ($datarow) {
			$this->name = $datarow['name'];
			$this->description = $datarow['description'];
		}
	}
	
	static public function GetAll() {
		$db = new DB();
		$rows = $db->SelectAllGroups();
		$ret = array();
		foreach ($rows as $row) {
			$ret[] = new Group($row);
		}
		return $ret;
	}
	
	static public function GetByName($name) {
		$db = new DB();
		$row = $db->SelectGroup($name);
		return new Group($row);
	}
	
	public function IsMember($user) {
		$ret = $this->db->SelectGroupMembership($user, $this->name);
		return $ret == 1;
	}
	
	public function GetMembers() {
		$members = $this->db->SelectGroupMembersByGroup($this->name);
		$ret = array();
		foreach ($members as $u) {
			$ret[] = new User($u);
		}
		return $ret;
	}
	
	public function Add($user) {
		$data = array('user_name'=> $user->username,
					  'group_name'=> $this->name);
		return $this->db->InsertGroupMember($data);
	}
	
	public function Remove($user) {
		return $this->db->DeleteGroupMember($this->name, $user->username);
	}
	
	public function Insert() {
		$data = array('name'=> $this->name,
					  'description'=> $this->description);
		return $this->db->InsertGroup($data);
	}
	
	public function Update() {
		$data = array('name'=> $this->name,
					  'description'=> $this->description);
		return $this->db->UpdateGroup($this->name, $data);
	}
	
}